#include "config.h"

#ifdef HAVE_UTIME_H
#include <utime.h>
#endif
#ifdef HAVE_DIRENT_H
#include <dirent.h>
#endif
#include <syslog.h>
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>

#include "vscan-trend_vsapi.h"

/* Configuration Section :-) */

/* which samba version is this VFS module compiled for:
 * Set SAMBA_VERSION_MAJOR to 3 for Samba 3.0 alpha0 or
 * to 2 for Samba 2.2.x
 * Set SAMBA_VERSION_MINOR to 2 if you're using Samba 2.2.2 or
 * to 1 if you're using Samba 2.2.0[a] or 0 for Samba 2.2.0[a]
 * If SAMBA_VERSION_MAJOR is set to 3, SAMBA_VERSION_MINOR
 * is ignored!
*/

#ifndef SAMBA_VERSION_MAJOR
# define SAMBA_VERSION_MAJOR 2
#endif

#ifndef SAMBA_VERSION_MINOR
# define SAMBA_VERSION_MINOR 2
#endif 

/* 0 = log only infected file, 1 = log every file access */

#ifndef VSCAN_TREND_VERBOSE_FILE_LOGGING
# define VSCAN_TREND_VERBOSE_FILE_LOGGING 0 
#endif

/* if a file is bigger than VSCAN_TREND_MAX_SIZE it won't be scanned. Has to be
   specified in bytes! If it set to 0, the file size check is disabled */

#ifndef VSCAN_TREND_MAX_SIZE 
# define VSCAN_TREND_MAX_SIZE 0 
#endif


/* End Configuration Section */


#ifndef SYSLOG_FACILITY
#define SYSLOG_FACILITY   LOG_USER
#endif

#ifndef SYSLOG_PRIORITY
#define SYSLOG_PRIORITY   LOG_NOTICE
#endif

#ifndef bool 
typedef int bool;
#endif 

#ifndef FALSE
# define FALSE  0
#endif /* ! FALSE */
#ifndef TRUE
# define TRUE   1
#endif /* ! TRUE */

#define NEWER_VSAPI 			1
#define REPORT_VIRUSNAME		1
#define T_MAXFILELEN                  1024


char VIR_NAME[512];

char working_dir[T_MAXFILELEN];

int vs_ret;
int vs_addr;

/* Our lame structure goes in here */
struct trophie_vs_type trophie_vs;

/* --- FUNCTIONS --- */

/* vscan_trend_init.c */
void vscan_trend_init(void);
void vscan_trend_end(void);

/* vscan_trend_core.c */
int scandir_handler(char *a);
int vscan_trend_scanfile(char *scan_file);
void vscan_trend_print(char *printMessage, ...);
int vs_virus_scan_file_callback_function(char *a, struct callback_type *b, int c, char *d);
int pre_extract_arch_func_callback(char *a);

